/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.ruoyi.common.core.utils.poi.ExcelUtil
 *  com.ruoyi.common.core.web.controller.BaseController
 *  com.ruoyi.common.core.web.domain.AjaxResult
 *  com.ruoyi.common.core.web.page.TableDataInfo
 *  com.ruoyi.common.log.annotation.Log
 *  com.ruoyi.common.log.enums.BusinessType
 *  com.ruoyi.common.security.annotation.RequiresPermissions
 *  com.ruoyi.common.security.utils.SecurityUtils
 *  com.ruoyi.system.api.domain.SysDept
 *  com.ruoyi.system.api.domain.SysRole
 *  com.ruoyi.system.api.domain.SysUser
 *  com.ruoyi.system.controller.SysRoleController
 *  com.ruoyi.system.domain.SysUserRole
 *  com.ruoyi.system.service.ISysDeptService
 *  com.ruoyi.system.service.ISysRoleService
 *  com.ruoyi.system.service.ISysUserService
 *  javax.servlet.http.HttpServletResponse
 *  org.springframework.beans.factory.annotation.Autowired
 *  org.springframework.validation.annotation.Validated
 *  org.springframework.web.bind.annotation.DeleteMapping
 *  org.springframework.web.bind.annotation.GetMapping
 *  org.springframework.web.bind.annotation.PathVariable
 *  org.springframework.web.bind.annotation.PostMapping
 *  org.springframework.web.bind.annotation.PutMapping
 *  org.springframework.web.bind.annotation.RequestBody
 *  org.springframework.web.bind.annotation.RequestMapping
 *  org.springframework.web.bind.annotation.RestController
 */
package com.ruoyi.system.controller;

import com.ruoyi.common.core.utils.poi.ExcelUtil;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.common.core.web.page.TableDataInfo;
import com.ruoyi.common.log.annotation.Log;
import com.ruoyi.common.log.enums.BusinessType;
import com.ruoyi.common.security.annotation.RequiresPermissions;
import com.ruoyi.common.security.utils.SecurityUtils;
import com.ruoyi.system.api.domain.SysDept;
import com.ruoyi.system.api.domain.SysRole;
import com.ruoyi.system.api.domain.SysUser;
import com.ruoyi.system.domain.SysUserRole;
import com.ruoyi.system.service.ISysDeptService;
import com.ruoyi.system.service.ISysRoleService;
import com.ruoyi.system.service.ISysUserService;
import java.util.List;
import javax.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping(value={"/role"})
public class SysRoleController
extends BaseController {
    @Autowired
    private ISysRoleService roleService;
    @Autowired
    private ISysUserService userService;
    @Autowired
    private ISysDeptService deptService;

    @RequiresPermissions(value={"system:role:list"})
    @GetMapping(value={"/list"})
    public TableDataInfo list(SysRole role) {
        this.startPage();
        List list = this.roleService.selectRoleList(role);
        return this.getDataTable(list);
    }

    @Log(title="角色管理", businessType=BusinessType.EXPORT)
    @RequiresPermissions(value={"system:role:export"})
    @PostMapping(value={"/export"})
    public void export(HttpServletResponse response, SysRole role) {
        List list = this.roleService.selectRoleList(role);
        ExcelUtil util = new ExcelUtil(SysRole.class);
        util.exportExcel(response, list, "角色数据");
    }

    @RequiresPermissions(value={"system:role:query"})
    @GetMapping(value={"/{roleId}"})
    public AjaxResult getInfo(@PathVariable Long roleId) {
        this.roleService.checkRoleDataScope(new Long[]{roleId});
        return this.success((Object)this.roleService.selectRoleById(roleId));
    }

    @RequiresPermissions(value={"system:role:add"})
    @Log(title="角色管理", businessType=BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@Validated @RequestBody SysRole role) {
        if (!this.roleService.checkRoleNameUnique(role)) {
            return this.error("新增角色'" + role.getRoleName() + "'失败，角色名称已存在");
        }
        if (!this.roleService.checkRoleKeyUnique(role)) {
            return this.error("新增角色'" + role.getRoleName() + "'失败，角色权限已存在");
        }
        role.setCreateBy(SecurityUtils.getUsername());
        return this.toAjax(this.roleService.insertRole(role));
    }

    @RequiresPermissions(value={"system:role:edit"})
    @Log(title="角色管理", businessType=BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@Validated @RequestBody SysRole role) {
        this.roleService.checkRoleAllowed(role);
        this.roleService.checkRoleDataScope(new Long[]{role.getRoleId()});
        if (!this.roleService.checkRoleNameUnique(role)) {
            return this.error("修改角色'" + role.getRoleName() + "'失败，角色名称已存在");
        }
        if (!this.roleService.checkRoleKeyUnique(role)) {
            return this.error("修改角色'" + role.getRoleName() + "'失败，角色权限已存在");
        }
        role.setUpdateBy(SecurityUtils.getUsername());
        return this.toAjax(this.roleService.updateRole(role));
    }

    @RequiresPermissions(value={"system:role:edit"})
    @Log(title="角色管理", businessType=BusinessType.UPDATE)
    @PutMapping(value={"/dataScope"})
    public AjaxResult dataScope(@RequestBody SysRole role) {
        this.roleService.checkRoleAllowed(role);
        this.roleService.checkRoleDataScope(new Long[]{role.getRoleId()});
        return this.toAjax(this.roleService.authDataScope(role));
    }

    @RequiresPermissions(value={"system:role:edit"})
    @Log(title="角色管理", businessType=BusinessType.UPDATE)
    @PutMapping(value={"/changeStatus"})
    public AjaxResult changeStatus(@RequestBody SysRole role) {
        this.roleService.checkRoleAllowed(role);
        this.roleService.checkRoleDataScope(new Long[]{role.getRoleId()});
        role.setUpdateBy(SecurityUtils.getUsername());
        return this.toAjax(this.roleService.updateRoleStatus(role));
    }

    @RequiresPermissions(value={"system:role:remove"})
    @Log(title="角色管理", businessType=BusinessType.DELETE)
    @DeleteMapping(value={"/{roleIds}"})
    public AjaxResult remove(@PathVariable Long[] roleIds) {
        return this.toAjax(this.roleService.deleteRoleByIds(roleIds));
    }

    @RequiresPermissions(value={"system:role:query"})
    @GetMapping(value={"/optionselect"})
    public AjaxResult optionselect() {
        return this.success((Object)this.roleService.selectRoleAll());
    }

    @RequiresPermissions(value={"system:role:list"})
    @GetMapping(value={"/authUser/allocatedList"})
    public TableDataInfo allocatedList(SysUser user) {
        this.startPage();
        List list = this.userService.selectAllocatedList(user);
        return this.getDataTable(list);
    }

    @RequiresPermissions(value={"system:role:list"})
    @GetMapping(value={"/authUser/unallocatedList"})
    public TableDataInfo unallocatedList(SysUser user) {
        this.startPage();
        List list = this.userService.selectUnallocatedList(user);
        return this.getDataTable(list);
    }

    @RequiresPermissions(value={"system:role:edit"})
    @Log(title="角色管理", businessType=BusinessType.GRANT)
    @PutMapping(value={"/authUser/cancel"})
    public AjaxResult cancelAuthUser(@RequestBody SysUserRole userRole) {
        return this.toAjax(this.roleService.deleteAuthUser(userRole));
    }

    @RequiresPermissions(value={"system:role:edit"})
    @Log(title="角色管理", businessType=BusinessType.GRANT)
    @PutMapping(value={"/authUser/cancelAll"})
    public AjaxResult cancelAuthUserAll(Long roleId, Long[] userIds) {
        return this.toAjax(this.roleService.deleteAuthUsers(roleId, userIds));
    }

    @RequiresPermissions(value={"system:role:edit"})
    @Log(title="角色管理", businessType=BusinessType.GRANT)
    @PutMapping(value={"/authUser/selectAll"})
    public AjaxResult selectAuthUserAll(Long roleId, Long[] userIds) {
        this.roleService.checkRoleDataScope(new Long[]{roleId});
        return this.toAjax(this.roleService.insertAuthUsers(roleId, userIds));
    }

    @RequiresPermissions(value={"system:role:query"})
    @GetMapping(value={"/deptTree/{roleId}"})
    public AjaxResult deptTree(@PathVariable(value="roleId") Long roleId) {
        AjaxResult ajax = AjaxResult.success();
        ajax.put("checkedKeys", (Object)this.deptService.selectDeptListByRoleId(roleId));
        ajax.put("depts", (Object)this.deptService.selectDeptTreeList(new SysDept()));
        return ajax;
    }
}

